topic "class IPC";
[2 $$0,0#00000000000000000000000000000000:Default]
[i448;a25;kKO9;2 $$1,0#37138531426314131252341829483380:class]
[l288;2 $$2,0#27521748481378242620020725143825:desc]
[0 $$3,0#96390100711032703541132217272105:end]
[H6;0 $$4,0#05600065144404261032431302351956:begin]
[i448;a25;kKO9;2 $$5,0#37138531426314131252341829483370:item]
[l288;a4;*@5;1 $$6,6#70004532496200323422659154056402:requirement]
[l288;i1121;b17;O9;~~~.1408;2 $$7,0#10431211400427159095818037425705:param]
[i448;b42;O9;2 $$8,8#61672508125594000341940100500538:tparam]
[b42;2 $$9,9#13035079074754324216151401829390:normal]
[{_} 
[s1;:IPC`:`:class: [@(0.0.255)3 class][3 _][*3 IPC]&]
[s2;%% Simple class providing mostly automatic and very easy to set 
up interprocess communication with request`-response model. No 
server application is needed, the role of server is performed 
by separate thread, in one of the running instances automatically 
(and is picked up by another instance if previous server exits). 
Protocol is easily defined using callbacks.&]
[s3; &]
[s0;i448;a25;kKO9;:noref:@(0.0.255) &]
[ {{10000F(128)G(128)@1 [s0;%% [* Public Method List]]}}&]
[s4; &]
[s5;:IPC`:`:WhenRequest: [_^Callback2^ Callback2]<String[@(0.0.255) `&],String[@(0.0.255) `&
]>_[* WhenRequest]&]
[s2;%% [* WhenRequest] is executed by server every time a request comes. 
First parameter is the request, second is for response that will 
be passed back to client. Using this callback, complete protocol 
should be defined (suiting your application needs, of course). 
Both messages and responses are automatically (un)escaped, so 
they can consist of any characters.&]
[s3; &]
[s4; &]
[s5;:IPC`:`:IPC`(int`): [* IPC]([@(0.0.255) int]_[*@3 port][@(0.0.255) `=][@3 9876])&]
[s2;%% Constructor. Parameter [%-*@3 port][%-  can be supplied to specify 
on which port the communication will be performed].&]
[s3;%% &]
[s4; &]
[s5;:IPC`:`:`~IPC`(`): [@(0.0.255) `~][* IPC]()&]
[s2;%% Destructor. Stops server thread `- this operation may take 
some time because of connection timeouts.&]
[s3; &]
[s4; &]
[s5;:IPC`:`:Request`(const String`&`): [_^String^ String]_[* Request]([@(0.0.255) const]_[_^String^ S
tring]_`&[*@3 msg])&]
[s2;%% Passes [%-*@3 msg] to server and returns it`'s response. Response 
is constructed by [^topic`:`/`/IPC`/src`/IPC`$en`-us`#IPC`:`:WhenRequest^ WhenReque
st] callback.&]
[s3;%% &]
[s4; &]
[s5;:IPC`:`:StartServer`(`): [@(0.0.255) void]_[* StartServer]()&]
[s2;%% Force the server to start in this instance. If another instance 
already runs as server, warning will be written to Cerr(). Ussually 
this is not needed since if there is no server runnng, it is 
started on first [^topic`:`/`/IPC`/src`/IPC`$en`-us`#IPC`:`:Request`(const String`&`)^ R
equest()] call.&]
[s3; &]
[s4; &]
[s5;:IPC`:`:StopServer`(`): [@(0.0.255) void]_[* StopServer]()&]
[s2;%% Stops server in this instance if it is running.&]
[s3; &]
[s4; &]
[s5;:IPC`:`:IsServer`(`): [@(0.0.255) bool]_[* IsServer]()&]
[s2;%% Returns true if this instance performs the role of server.&]
[s3; &]
[s0; ]