topic "class IPC2 : public IPC";
[2 $$0,0#00000000000000000000000000000000:Default]
[i448;a25;kKO9;2 $$1,0#37138531426314131252341829483380:class]
[l288;2 $$2,0#27521748481378242620020725143825:desc]
[0 $$3,0#96390100711032703541132217272105:end]
[H6;0 $$4,0#05600065144404261032431302351956:begin]
[i448;a25;kKO9;2 $$5,0#37138531426314131252341829483370:item]
[l288;a4;*@5;1 $$6,6#70004532496200323422659154056402:requirement]
[l288;i1121;b17;O9;~~~.1408;2 $$7,0#10431211400427159095818037425705:param]
[i448;b42;O9;2 $$8,8#61672508125594000341940100500538:tparam]
[b42;2 $$9,9#13035079074754324216151401829390:normal]
[{_} 
[s1;:IPC2`:`:class: [@(0.0.255)3 class][3 _][*3 IPC2][3 _:_][@(0.0.255)3 public][3 _][*@3;3 IPC]&]
[s2;%% Extension of [^topic`:`/`/IPC`/src`/IPC`$en`-us`#IPC`:`:class^ IPC] 
class, adding the possibility to communicate between clients. 
This is implemented by polling and marking each client by unique 
identificator.&]
[s0;%% &]
[s2;%% See also class [^topic`:`/`/IPC`/src`/IPC`$en`-us`#IPC`:`:class^ IPC], 
all of it`'s public functions are accessible in IPC2 as well. 
&]
[s3; &]
[s0;i448;a25;kKO9;@(0.0.255) &]
[s2; [*@6 Important]: When assigning your callbacks to [^topic`:`/`/IPC`/src`/IPC`$en`-us`#IPC`:`:WhenRequest^ W
henRequest], you MUST use [^topic`:`/`/Core`/src`/Callbacks`$en`-us^ operator 
<<], otherwise IPC2 internal protocol will be overwritten and 
the class will not work correctly!&]
[s0; &]
[ {{10000F(128)G(128)@1 [s0;%% [* Public Method List]]}}&]
[s4; &]
[s5;:IPC2`:`:WhenMsg: [_^Callback1^ Callback1]<String[@(0.0.255) `&]>_[* WhenMsg]&]
[s2;%% [* WhenMsg] is executed each time a message is delivered to 
client via [^topic`:`/`/IPC`/src`/IPC2`$en`-us`#IPC2`:`:Broadcast`(String`)^ Broadc
ast] or [^topic`:`/`/IPC`/src`/IPC2`$en`-us`#IPC2`:`:Send`(int`,String`)^ Send] 
function call. The only argument is the message itself.&]
[s3; &]
[s4; &]
[s5;:IPC2`:`:IPC2`(int`,int`): [* IPC2]([@(0.0.255) int]_[*@3 port][@(0.0.255) `=][@3 9876],[@(0.0.255) i
nt]_[*@3 interval][@(0.0.255) `=][@3 100])&]
[s2;%% Constructor. Parameter [%-*@3 port][%-  can be supplied to specify 
on which port the communication will be performed]. Parameter 
[%-*@3 interval][%-  specifies the polling interval].&]
[s3;%% &]
[s4; &]
[s5;:IPC2`:`:`~IPC2`(`): [@(0.0.255) `~][* IPC2]()&]
[s2;%% Destructor. Tries to ensure that all the messages were delivered 
by waiting up to 20 [^topic`:`/`/IPC`/src`/IPC2`$en`-us`#IPC2`:`:IPC2`(int`,int`)^ i
nterval]s. After this timeout instance is closed even if undelivered 
messages still exist.&]
[s3; &]
[s4; &]
[s5;:IPC2`:`:Broadcast`(String`): [@(0.0.255) void]_[* Broadcast]([_^String^ String]_[*@3 msg
])&]
[s2;%% Sends [%-*@3 msg] to every active client.&]
[s3;%% &]
[s4; &]
[s5;:IPC2`:`:Send`(int`,String`): [@(0.0.255) void]_[* Send]([@(0.0.255) int]_[*@3 client`_id
],[_^String^ String]_[*@3 msg])&]
[s2;%% Send [%-*@3 msg] to client specified by [%-*@3 client`_id]. To 
determine correct [%-*@3 client`_id] use [^topic`:`/`/IPC`/src`/IPC2`$en`-us`#IPC2`:`:GetId`(`)^ G
etId], [^topic`:`/`/IPC`/src`/IPC2`$en`-us`#IPC2`:`:GetClientIds`(`)^ GetClientIds] 
or [^topic`:`/`/IPC`/src`/IPC2`$en`-us`#IPC2`:`:GetServerId`(`)^ GetServerId].&]
[s3;%% &]
[s4; &]
[s5;:IPC2`:`:GetId`(`): [@(0.0.255) int]_[* GetId]()&]
[s2;%% Returns unique client identificator of this instance.&]
[s3; &]
[s4; &]
[s5;:IPC2`:`:GetClientIds`(`): [_^Vector^ Vector]<[@(0.0.255) int]>_[* GetClientIds]()&]
[s2;%% Returns Vector containing client identificators of all currently 
connected clients.&]
[s3; &]
[s4; &]
[s5;:IPC2`:`:GetServerId`(`): [@(0.0.255) int]_[* GetServerId]()&]
[s2;%% Returns identificator of instance that performs role of the 
server at the moment.&]
[s3; &]
[s0; ]